# TODO:
# - include examples in package

# Conditional build:
%bcond_without  python2 # Python 2.x version
%bcond_without  python3 # Python 3.x version (available as 'py3lint')

Summary:	Python tool that checks if a module satisfy a coding standard
Summary(pl.UTF-8):	Pythonowe narzędzie sprawdzające zgodność modułu ze standardem kodowania
Name:		pylint
Version:	1.4.0
Release:	1
License:	GPL v2+
Group:		Development/Languages/Python
Source0:	https://pypi.python.org/packages/source/p/pylint/pylint-%{version}.tar.gz
# Source0-md5:	c164738f90213981db5d3297a60b4138
Patch0:		%{name}-type_error.patch
URL:		http://www.pylint.org/
%if %{with python2}
BuildRequires:	python-devel
BuildRequires:	python-modules >= 1:2.5
%endif
%if %{with python3}
BuildRequires:	python3-2to3
BuildRequires:	python3-devel
BuildRequires:	python3-distribute
BuildRequires:	python3-modules >= 1:3.2
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.219
BuildRequires:	sphinx-pdg
Requires:	python-astroid >= 0.24.3
Requires:	python-logilab-common >= 0.53.0
Requires:	python-modules
Suggests:	python-devel-src
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# /etc/pylintrc is deliberately packaged to both packages with same name
%define		_duplicate_files_terminate_build	0

%description
Python tool that checks if a module satisfy a coding standard.

%description -l pl.UTF-8
Narzędzie sprawdzające zgodność modułów napisanych w języku Python z
regułami tworzenia kodu źródłowego.

%package gui
Summary:	GUI for pylint
Summary(pl.UTF-8):	Graficzny interfejs użytkownika dla pylinta
Group:		Development/Languages/Python
Requires:	%{name} = %{version}-%{release}
Requires:	python-tkinter

%description gui
Tk based GUI for pylint.

%description gui -l pl.UTF-8
Oparty na bibliotece Tk graficzny interfejs użytkownika dla pylinta.

%package -n py3lint
Summary:	Python tool that checks if a module satisfy a coding standard
Summary(pl.UTF-8):	Pythonowe narzędzie sprawdzające zgodność modułu ze standardem kodowania
Group:		Development/Languages/Python
Requires:	python3-astroid >= 0.24.3
Requires:	python3-logilab-common >= 0.53.0
Obsoletes:	pylint-python3 < 1.0.0-2

%description -n py3lint
Python tool that checks if a module satisfy a coding standard.

Python 3.x version, available via the 'py3lint' command.

%description -n py3lint -l pl.UTF-8
Narzędzie sprawdzające zgodność modułów napisanych w języku Python z
regułami tworzenia kodu źródłowego.

Wersja dla Pythona 3.x, dostępna przez polecenie 'py3lint'.

%package -n py3lint-gui
Summary:	GUI for pylint
Summary(pl.UTF-8):	Graficzny interfejs użytkownika dla pylinta
Group:		Development/Languages/Python
Requires:	py3lint = %{version}-%{release}
Requires:	python3-tkinter
Obsoletes:	pylint-python3-gui < 1.0.0-2

%description -n py3lint-gui
Tk based GUI for pylint.

%description -n py3lint-gui -l pl.UTF-8
Oparty na bibliotece Tk graficzny interfejs użytkownika dla pylinta.

%prep
%setup -q
%patch0 -p1

%build
%if %{with python2}
%{__python} setup.py build
%else
# for sphinx
install -d build/lib
ln -sf ../.. build/lib/pylint
%endif

%if %{with python3}
export NO_SETUPTOOLS=1
%{__python3} setup.py build --build-base=build3
unset NO_SETUPTOOLS
%endif

export PYTHONPATH=$PWD/build/lib
%{__make} -C doc text

%install
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir},%{_mandir}/man1}

%if %{with python3}
export NO_SETUPTOOLS=1
%{__python3} setup.py build --build-base=build3 install \
	--optimize=2 \
	--root=$RPM_BUILD_ROOT

unset NO_SETUPTOOLS
mv $RPM_BUILD_ROOT%{_bindir}/epylint $RPM_BUILD_ROOT%{_bindir}/epy3lint
mv $RPM_BUILD_ROOT%{_bindir}/pylint $RPM_BUILD_ROOT%{_bindir}/py3lint
mv $RPM_BUILD_ROOT%{_bindir}/pylint-gui $RPM_BUILD_ROOT%{_bindir}/py3lint-gui
mv $RPM_BUILD_ROOT%{_bindir}/pyreverse $RPM_BUILD_ROOT%{_bindir}/py3reverse
cp -p man/epylint.1 $RPM_BUILD_ROOT%{_mandir}/man1/epy3lint.1
cp -p man/pylint.1 $RPM_BUILD_ROOT%{_mandir}/man1/py3lint.1
cp -p man/pylint-gui.1 $RPM_BUILD_ROOT%{_mandir}/man1/py3lint-gui.1
cp -p man/pyreverse.1 $RPM_BUILD_ROOT%{_mandir}/man1/py3reverse.1
%endif

%if %{with python2}
%{__python} setup.py install \
	--optimize=2 \
	--root=$RPM_BUILD_ROOT
%py_postclean
cp -p man/*.1 $RPM_BUILD_ROOT%{_mandir}/man1
%endif

cp -p examples/pylintrc $RPM_BUILD_ROOT%{_sysconfdir}/pylintrc

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc ChangeLog README examples/* doc/_build/text/*.txt
%attr(755,root,root) %{_bindir}/epylint
%attr(755,root,root) %{_bindir}/pylint
%attr(755,root,root) %{_bindir}/pyreverse
%attr(755,root,root) %{_bindir}/symilar
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/pylintrc
%{py_sitescriptdir}/pylint
%{py_sitescriptdir}/pylint-%{version}-py*.egg-info
%{_mandir}/man1/epylint.1*
%{_mandir}/man1/pylint.1*
%{_mandir}/man1/pyreverse.1*
%{_mandir}/man1/symilar.1*

%files gui
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/pylint-gui
%{_mandir}/man1/pylint-gui.1*
%endif

%if %{with python3}
%files -n py3lint
%defattr(644,root,root,755)
%doc ChangeLog README examples/* doc/_build/text/*.txt
%attr(755,root,root) %{_bindir}/epy3lint
%attr(755,root,root) %{_bindir}/py3lint
%attr(755,root,root) %{_bindir}/py3reverse
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/pylintrc
%{py3_sitescriptdir}/pylint
%{py3_sitescriptdir}/pylint-%{version}-py*.egg-info
%{_mandir}/man1/epy3lint.1*
%{_mandir}/man1/py3lint.1*
%{_mandir}/man1/py3reverse.1*

%files -n py3lint-gui
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/py3lint-gui
%{_mandir}/man1/py3lint-gui.1*
%endif
%changelog
* Tue Nov 25 2014 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/pylint.git;a=log;h=master

* Tue Nov 25 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> ae8aadb
- up to 1.4.0

* Sun Oct 19 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 738e20e
- python 3.4
- release 2 (by relup.sh)

* Thu May 08 2014 Jacek Konieczny <j.konieczny@eggsoft.pl> cba3691
- Do not use installed pylint for generating docs

* Thu May 08 2014 Jacek Konieczny <j.konieczny@eggsoft.pl> 26ceed7
- Revert "python3 build requires python2 version of 2to3"

* Thu May 08 2014 Jacek Konieczny <j.konieczny@eggsoft.pl> 5971015
- Version: 1.2.1

* Sun Feb 16 2014 Jakub Bogusz <qboosh@pld-linux.org> e6bafd8
- updated to 1.1.0

* Sat Dec 14 2013 Jan Rękorajski <baggins@pld-linux.org> 439af2e
- fix deps
- rel 4

* Mon Dec 09 2013 Elan Ruusamäe <glen@delfi.ee> 1ee582a
- allow /etc/pylintrc packaged to py2/py3 packages

* Mon Dec 09 2013 Elan Ruusamäe <glen@delfi.ee> abbf502
- fix doc

* Mon Dec 09 2013 Elan Ruusamäe <glen@delfi.ee> e791047
- python3 build requires python2 version of 2to3

* Mon Dec 09 2013 Elan Ruusamäe <glen@delfi.ee> 704b747
- rename python packages to py3lint and py3lint-gui

* Sun Sep 08 2013 Jakub Bogusz <qboosh@pld-linux.org> 243b3ec
- updated astng -> astroid dependency

* Sat Sep 07 2013 Jakub Bogusz <qboosh@pld-linux.org> d948a3e
- updated to 1.0.0

* Mon May 27 2013 Jacek Konieczny <jajcus@jajcus.net> f7cd7b1
- Build Python 3 version too (as py3lint)

* Wed May 15 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> b4835e9
- bump astng req

* Wed May 15 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> ad173d2
- up to 0.28.0

* Sun Apr 07 2013 Jakub Bogusz <qboosh@pld-linux.org> 6abb03e
- verbose files/package pylint-gui(1) man in proper package

* Tue Dec 20 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> d354537
- up to 0.25.1

* Sat Sep 03 2011 Jacek Konieczny <jajcus@pld-linux.org> 8b70ac8
- workaround for the http://www.logilab.org/ticket/74087 bug

* Sat Sep 03 2011 Jacek Konieczny <jajcus@pld-linux.org> f5425a3
- Version: 0.24.0
- relative_import_from patch dropped (applied upstream)

